diff --git a/modules/features/chatbot/mainChatbot.py b/modules/features/chatbot/mainChatbot.py
index acb9a0e6..6f0cf770 100644
--- a/modules/features/chatbot/mainChatbot.py
+++ b/modules/features/chatbot/mainChatbot.py
@@ -315,6 +315,210 @@ async def _check_workflow_stopped(interfaceDbChat, workflowId: str) -> bool:
         return False
 
 
+def _buildWebResearchQuery(userPrompt: str, workflowMessages: List, queryResults: Optional[Dict[str, Any]] = None) -> str:
+    """
+    Build enriched web research query by extracting product context from conversation history and current prompt.
+    
+    Extracts product information from:
+    1. Current user prompt (article numbers, product mentions)
+    2. Database query results (if available)
+    3. Previous assistant messages (conversation history)
+    
+    Args:
+        userPrompt: Current user prompt
+        workflowMessages: List of workflow messages (conversation history)
+        queryResults: Optional database query results to extract product info from
+        
+    Returns:
+        Enriched search query string
+    """
+    # Normalize user prompt for detection
+    prompt_lower = userPrompt.lower().strip()
+    
+    # Patterns that indicate a search request
+    search_patterns = [
+        "ja", "yes", "oui", "si",
+        "such", "suche", "search", "recherche", "recherchier",
+        "internet", "web", "online",
+        "datenblatt", "datasheet", "fiche technique",
+        "mehr informationen", "more information", "plus d'information",
+        "weitere informationen", "further information", "additional information"
+    ]
+    
+    # Check if current prompt contains search-related keywords
+    has_search_intent = any(pattern in prompt_lower for pattern in search_patterns)
+    
+    # Extract product information - try multiple sources
+    article_number = None
+    article_description = None
+    supplier = None
+    
+    # Pattern for article numbers like "6AV2 181-8XP00-0AX0" or "6AV2181-8XP00-0AX0"
+    article_patterns = [
+        r'\b[A-Z0-9]{2,}\s+[0-9]{3,}-[A-Z0-9-]+\b',  # With space: "6AV2 181-8XP00-0AX0"
+        r'\b[A-Z0-9]{4,}[\s-][A-Z0-9-]{6,}\b',  # General pattern
+        r'\b[A-Z]{2,}[0-9]+\s+[0-9]+-[A-Z0-9-]+\b',  # Specific Siemens pattern
+    ]
+    
+    # 1. First, try to extract from current user prompt
+    for pattern in article_patterns:
+        matches = re.findall(pattern, userPrompt)
+        if matches:
+            article_number = matches[0]
+            logger.info(f"Extracted article number from user prompt: {article_number}")
+            break
+    
+    # 2. Try to extract from database query results if available
+    # Always check queryResults to enrich with product description and supplier, even if article_number was already found
+    if queryResults:
+        # Look for article numbers in query result text (if not already found)
+        if not article_number:
+            for key in queryResults.keys():
+                if key.startswith("query_") and not key.endswith("_error") and not key.endswith("_data"):
+                    result_text = queryResults.get(key, "")
+                    if isinstance(result_text, str):
+                        for pattern in article_patterns:
+                            matches = re.findall(pattern, result_text)
+                            if matches:
+                                article_number = matches[0]
+                                logger.info(f"Extracted article number from query results: {article_number}")
+                                break
+                        if article_number:
+                            break
+        
+        # Always check data arrays for product description and supplier (even if article_number already found)
+        for key in queryResults.keys():
+            if key.startswith("query_") and not key.endswith("_error") and not key.endswith("_data"):
+                data_key = f"{key}_data"
+                if data_key in queryResults:
+                    data_array = queryResults[data_key]
+                    if isinstance(data_array, list) and len(data_array) > 0:
+                        # Look for article number in first row (if not already found)
+                        first_row = data_array[0]
+                        if isinstance(first_row, dict):
+                            # Check common article number fields (if not already found)
+                            if not article_number:
+                                for field in ["Artikelnummer", "Artikelkürzel", "article_number", "articleNumber"]:
+                                    if field in first_row and first_row[field]:
+                                        article_number = str(first_row[field])
+                                        logger.info(f"Extracted article number from query data: {article_number}")
+                                        break
+                            
+                            # Always check article description (can enrich even if article_number already found)
+                            if not article_description:
+                                for field in ["Artikelbezeichnung", "Bezeichnung", "article_description", "description"]:
+                                    if field in first_row and first_row[field]:
+                                        article_description = str(first_row[field])
+                                        logger.info(f"Extracted article description from query data: {article_description}")
+                                        break
+                            
+                            # Always check supplier (can enrich even if article_number already found)
+                            if not supplier:
+                                for field in ["Lieferant", "Supplier", "supplier"]:
+                                    if field in first_row and first_row[field]:
+                                        supplier = str(first_row[field])
+                                        logger.info(f"Extracted supplier from query data: {supplier}")
+                                        break
+                            
+                            # If we found all needed info, we can stop
+                            if article_number and article_description and supplier:
+                                break
+    
+    # 3. Extract from previous assistant messages (conversation history)
+    if not article_number or not article_description:
+        for msg in reversed(workflowMessages[-10:]):
+            if msg.role == "assistant":
+                message_text = msg.message
+                
+                # Extract article number if not found yet
+                if not article_number:
+                    for pattern in article_patterns:
+                        matches = re.findall(pattern, message_text)
+                        if matches:
+                            article_number = matches[0]
+                            break
+                
+                # Extract article description if not found yet
+                if not article_description:
+                    description_patterns = [
+                        r'Es handelt sich um\s+([^\.]+)',
+                        r'It is a\s+([^\.]+)',
+                        r'C\'est\s+([^\.]+)',
+                        r'Bezeichnung:\s*([^\n]+)',
+                        r'Description:\s*([^\n]+)',
+                        r'Artikelbezeichnung:\s*([^\n]+)',
+                        r'Artikelbezeichnung:\s*([^\n]+)'
+                    ]
+                    for pattern in description_patterns:
+                        match = re.search(pattern, message_text, re.IGNORECASE)
+                        if match:
+                            article_description = match.group(1).strip()
+                            break
+                
+                # Extract supplier if not found yet
+                if not supplier:
+                    supplier_patterns = [
+                        r'von\s+([A-Z][A-Za-z\s]+(?:AG|GmbH|Ltd|Inc|Corp)?)',
+                        r'from\s+([A-Z][A-Za-z\s]+(?:AG|GmbH|Ltd|Inc|Corp)?)',
+                        r'Lieferant:\s*([^\n]+)',
+                        r'Supplier:\s*([^\n]+)'
+                    ]
+                    for pattern in supplier_patterns:
+                        match = re.search(pattern, message_text, re.IGNORECASE)
+                        if match:
+                            supplier = match.group(1).strip()
+                            break
+                
+                # Stop if we found everything
+                if article_number and article_description and supplier:
+                    break
+    
+    # Build enriched search query
+    query_parts = []
+    
+    # If we have search intent but no product info, try to use the user prompt intelligently
+    if has_search_intent and not article_number and not article_description:
+        # Try to extract meaningful parts from the prompt
+        # Remove common search phrases and keep the product-related parts
+        cleaned_prompt = userPrompt
+        for phrase in ["recherchier nach", "recherche", "suche nach", "search for", "find", "informationen zu", "information about", "weitere informationen", "further information"]:
+            cleaned_prompt = re.sub(phrase, "", cleaned_prompt, flags=re.IGNORECASE)
+        cleaned_prompt = cleaned_prompt.strip()
+        
+        # If cleaned prompt still has content and is different, use it
+        if cleaned_prompt and cleaned_prompt != userPrompt and len(cleaned_prompt) > 10:
+            query_parts.append(cleaned_prompt)
+    
+    # Add article description if found
+    if article_description:
+        query_parts.append(article_description)
+    
+    # Add article number if found
+    if article_number:
+        query_parts.append(article_number)
+    
+    # Add supplier if found
+    if supplier:
+        query_parts.append(supplier)
+    
+    # Add "Datenblatt" or "datasheet" if user requested it or if we have product info
+    if "datenblatt" in prompt_lower or "datasheet" in prompt_lower or "fiche technique" in prompt_lower:
+        query_parts.append("Datenblatt")
+    elif query_parts:
+        # If we have product info but no explicit request for datasheet, add it anyway
+        query_parts.append("Datenblatt")
+    
+    # If we found product information or built a meaningful query, use it
+    if query_parts:
+        enriched_query = " ".join(query_parts)
+        logger.info(f"Built enriched search query: '{enriched_query}' from context (original: '{userPrompt}')")
+        return enriched_query
+    else:
+        # Fall back to original prompt, but try to clean it up
+        logger.info(f"No product context found, using original prompt: '{userPrompt}'")
+        return userPrompt
+
+
 async def _processChatbotMessage(
     services,
     workflowId: str,
@@ -398,6 +602,11 @@ async def _processChatbotMessage(
         
         logger.info(f"Analysis: DB={needsDatabaseQuery}, Web={needsWebResearch}, SQL queries={len(sql_queries)}")
         
+        # Build initial enriched web research query if needed (for logging, will be rebuilt after DB queries)
+        enriched_web_query = None
+        if needsWebResearch:
+            enriched_web_query = _buildWebResearchQuery(userInput.prompt, workflow.messages)
+        
         # Build list of queries to stream back
         queries = []
         
@@ -414,7 +623,7 @@ async def _processChatbotMessage(
         if needsWebResearch:
             queries.append({
                 "type": "web",
-                "query": userInput.prompt,
+                "query": enriched_web_query or userInput.prompt,
                 "reasoning": reasoning
             })
         
@@ -499,8 +708,17 @@ async def _processChatbotMessage(
             await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Suche im Internet nach Informationen...")
             
             try:
+                # Rebuild enriched query with database results if available (better product context)
+                web_research_query = _buildWebResearchQuery(
+                    userInput.prompt, 
+                    workflow.messages, 
+                    queryResults if queryResults else None
+                )
+                
+                logger.info(f"Using enriched web research query: '{web_research_query}'")
+                
                 researchResult = await services.web.performWebResearch(
-                    prompt=userInput.prompt,
+                    prompt=web_research_query,
                     urls=[],
                     country=None,
                     language=userInput.userLanguage or "de",
@@ -510,7 +728,7 @@ async def _processChatbotMessage(
                 webResearchResults = json.dumps(researchResult, ensure_ascii=False, indent=2) if isinstance(researchResult, dict) else str(researchResult)
                 await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Internet-Recherche abgeschlossen")
             except Exception as e:
-                logger.error(f"Web research failed: {e}")
+                logger.error(f"Web research failed: {e}", exc_info=True)
                 webResearchResults = f"Web research error: {str(e)}"
                 await _emit_log_and_event(interfaceDbChat, workflowId, event_manager, "Internet-Recherche fehlgeschlagen", log_type="warning")
         
diff --git a/modules/services/serviceAi/mainServiceAi.py b/modules/services/serviceAi/mainServiceAi.py
index a07aa441..6341c895 100644
--- a/modules/services/serviceAi/mainServiceAi.py
+++ b/modules/services/serviceAi/mainServiceAi.py
@@ -383,15 +383,36 @@ Respond with ONLY a JSON object in this exact format:
             operationType=opType.value
         )
         
-        self.services.chat.storeWorkflowStat(
-            self.services.workflow, 
-            response, 
-            f"ai.{opType.name.lower()}"
-        )
+        # Try to store workflow stats, but don't fail if workflow is None (e.g., in chatbot context)
+        try:
+            self.services.chat.storeWorkflowStat(
+                self.services.workflow, 
+                response, 
+                f"ai.{opType.name.lower()}"
+            )
+        except Exception as e:
+            # Log but don't fail - workflow might be None in some contexts (e.g., chatbot)
+            logger.debug(f"Could not store workflow stat (workflow may be None): {str(e)}")
         
         self.services.chat.progressLogUpdate(aiOperationId, 0.9, f"{opType.name} completed")
         self.services.chat.progressLogFinish(aiOperationId, True)
         
+        # Preserve metadata from response if available (e.g., results_with_content from Tavily)
+        # Check if response has metadata attribute (AiCallResponse from callAi)
+        if hasattr(response, 'metadata') and response.metadata:
+            # If metadata is a dict, store it in additionalData
+            if isinstance(response.metadata, dict):
+                if not metadata.additionalData:
+                    metadata.additionalData = {}
+                metadata.additionalData.update(response.metadata)
+            # If metadata is an object with attributes, extract them
+            elif hasattr(response.metadata, '__dict__'):
+                if not metadata.additionalData:
+                    metadata.additionalData = {}
+                for key, value in response.metadata.__dict__.items():
+                    if not key.startswith('_'):
+                        metadata.additionalData[key] = value
+        
         return AiResponse(
             content=response.content,
             metadata=metadata
